import rclpy

from .dataset_interface import DataSet
from .resourceset_interface import ResourceSet
from .skillsset_interface import SkillsSet

class SkillsetInterface:
    """Skillset Interface for skillset {{ skillset.name }}
    """

    def __init__(self, **kwargs):
        self.__name = '{{ skillset.name }}'
        self.__data = DataSet(**kwargs)
        self.__resources = ResourceSet(**kwargs)
        self.__skills = SkillsSet(**kwargs)

    def __del__(self):
        del self.__data
        del self.__resources
        del self.__skills

    def destroy_nodes(self):
        self.__data.destroy_nodes()
        self.__resources.destroy_nodes()
        self.__skills.destroy_nodes()

    @property
    def name(self):
        return self.__name

    @property
    def data(self) -> DataSet:
        """Get clients to skillset data."""
        return self.__data

    @property
    def resources(self) -> ResourceSet:
        """Get clients to skillset resources."""
        return self.__resources

    @property
    def skills(self) -> SkillsSet:
        """Get clients to skillset skills."""
        return self.__skills
